unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, 
  StdCtrls, ExtCtrls, Gauges, EFiMgr;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    EdtOrigem: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EdtDestino: TEdit;
    RadGrpAcao: TRadioGroup;
    GroupBox2: TGroupBox;
    ChkBoxDateTime: TCheckBox;
    FileManager: TEvFileManager;
    ChkBoxAttr: TCheckBox;
    ChkBoxOcultos: TCheckBox;
    ChkBoxSistema: TCheckBox;
    ChkBoxDiretorio: TCheckBox;
    ChkBoxSobrepor: TCheckBox;
    BtnAcao: TButton;
    GroupBox3: TGroupBox;
    PanelGauge: TPanel;
    GaugeProgress: TGauge;
    Label3: TLabel;
    LabBytesCopiados: TLabel;
    LabTotalBytes: TLabel;
    LabDe: TLabel;
    LabPara: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LabAcao: TLabel;
    BtnFechar: TButton;
    BtnCancela: TButton;
    ChkBoxConfirmar: TCheckBox;
    ChkBoxSoLeitura: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure RadGrpAcaoClick(Sender: TObject);
    procedure BtnAcaoClick(Sender: TObject);
    function GetAction: TEvFileAction;
    function GetOptions: TEvFileOptions;
    procedure FileManagerStart(Sender: TObject);
    procedure FileManagerProcessFile(Sender: TObject; var Skip: Boolean);
    procedure FileManagerProgress(Sender: TObject);
    procedure FileManagerEnd(Sender: TObject; Status: TEvFileStatus);
    procedure FileManagerCreateDirectory(Sender: TObject; var CanCreate: Boolean);
    procedure FileManagerOverwrite(Sender: TObject; var CanOverwrite: Boolean);
    procedure FileManagerError(Sender: TObject; Error: TEvFileError);
    procedure BtnFecharClick(Sender: TObject);
    procedure BtnCancelaClick(Sender: TObject);
    function GetProcess(I: Integer): string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ FormCreate }
procedure TForm1.FormCreate(Sender: TObject);
begin
  {reduz o tamanho do formulrio}
  Form1.Height := 225;
end;


{ RadGrpAcaoClick }
procedure TForm1.RadGrpAcaoClick(Sender: TObject);
begin
  {altera o Caption do boto de acordo com a ao escolhida}
  BtnAcao.Caption := RadGrpAcao.Items[RadGrpAcao.ItemIndex];
end;


{ BtnAcaoClick }
procedure TForm1.BtnAcaoClick(Sender: TObject);
begin
  {ajusta FileManager e executa}
  FileManager.Source := EdtOrigem.Text;
  FileManager.Destination := EdtDestino.Text;
  FileManager.Action := GetAction;
  FileManager.Options := GetOptions;
  {muda o cursor enquanto no ocorre evento OnStart}
  Screen.Cursor := crHourGlass;
  {executa}
  FileManager.Execute;
end;


{ GetAction }
function TForm1.GetAction: TEvFileAction;
begin
  Result := faCopy;
  {determina a ao baseada no opo escolhida}
  case RadGrpAcao.ItemIndex of
    0: Result := faCopy;
    1: Result := faRename;
    2: Result := faDelete;
    3: Result := faMove;
  end;
end;


{ GetOptions }
function TForm1.GetOptions: TEvFileOptions;
begin
  Result := [];
  {verifica quais as opes foram escolhidas}
  if ChkBoxDateTime.Checked then
    Result := Result + [foCopyDateTime];
  if ChkBoxAttr.Checked then
    Result := Result + [foCopyAttr];
  if ChkBoxOcultos.Checked then
    Result := Result + [foHiddenFiles];
  if ChkBoxSistema.Checked then
    Result := Result + [foSysFiles];
  if ChkBoxSoLeitura.Checked then
    Result := Result + [foReadOnlyFiles];
  if ChkBoxDiretorio.Checked then
    Result := Result + [foCreateDir];
  if ChkBoxSobrepor.Checked then
    Result := Result + [foOverwrite];
end;


{ FileManagerStart }
procedure TForm1.FileManagerStart(Sender: TObject);
var
  Frase: string;
begin
  {retorna cursor ao normal}
  Screen.Cursor := crDefault;
  {confirma o incio do processo}
  Frase := 'Os arquivos selecionados sero ' + GetProcess(1) +
    '. Confirma o incio do processo?';
  if MessageDlg(Frase, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      {faz ajuste no formulrio}
      BtnAcao.Enabled := False;
      BtnCancela.Enabled := True;
      Form1.Height := 358;
      GaugeProgress.Progress := 0;
      LabTotalBytes.Caption := 'Total de bytes ' + FormatFloat('#,##0', FileManager.BytesCount);
      LabAcao.Caption := GetProcess(2);
      LabDe.Caption := '';
      LabPara.Caption := '';
      if FileManager.Action = faDelete then
        LabPara.Visible := False
      else
        LabPara.Visible := True;
      Application.ProcessMessages;
    end
  else
    {caso no confirme o processo  abortado}
    FileManager.Abort;
end;


{ GetProcess }
function TForm1.GetProcess(I: Integer): string;
begin
  {retorna uma string com o nome do processo em diversas situaes}
  if I = 1 then
    case RadGrpAcao.ItemIndex of
      0: Result := 'copiados';
      1: Result := 'renomeados';
      2: Result := 'deletados';
      3: Result := 'movidos';
    end
  else if I = 2 then
    case RadGrpAcao.ItemIndex of
      0: Result := 'Copiando...';
      1: Result := 'Renomeando...';
      2: Result := 'Deletando...';
      3: Result := 'Movendo...';
    end
  else if I = 3 then
    case RadGrpAcao.ItemIndex of
      0: Result := 'Copiar';
      1: Result := 'Renomear';
      2: Result := 'Deletar';
      3: Result := 'Mover';
    end
  else if I = 4 then
    case RadGrpAcao.ItemIndex of
      0: Result := 'copiado';
      1: Result := 'renomeado';
      2: Result := 'deletado';
      3: Result := 'movido';
    end;
end;


{ FileManagerProcessFile }
procedure TForm1.FileManagerProcessFile(Sender: TObject; var Skip: Boolean);
var
  S: string;
begin
  {atualiza informaes sobre os arquivos}
  LabDe.Caption := FileManager.InfoSrc.Path + FileManager.InfoSrc.Name;
  LabPara.Caption := FileManager.InfoDest.Path + FileManager.InfoDest.Name;
  {confirma ao para cada arquivo}
  if ChkBoxConfirmar.Checked then
    begin
      S := GetProcess(3) + ' o arquivo ' + #13#13#9 + LabDe.Caption;
      if FileManager.Action <> faDelete then
        S := S + #13#13 + 'para este destino' + #13#13#9 + LabPara.Caption;
      if MessageDlg(S, mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
        Skip := True;
    end;
end;


{ FileManagerProgress }
procedure TForm1.FileManagerProgress(Sender: TObject);
begin
  {atualiza informaes}
  GaugeProgress.Progress := FileManager.Progress;
  LabBytesCopiados.Caption := FormatFloat('#,##0', FileManager.BytesProc) +
    ' bytes processados';
end;


{ FileManagerEnd }
procedure TForm1.FileManagerEnd(Sender: TObject; Status: TEvFileStatus);
var
  SArq, S: string;
begin
  {arquivos processados}
  SArq := 'Foram ' + GetProcess(1) + ' ' + FormatFloat('#,##0', FileManager.FilesProc) +
    ' de um total de ' + FormatFloat('#,##0', FileManager.ListSrc.Count) + ' arquivos.';
  {frase de informao}
  case Status of
    fsNone: S := 'Nenhum arquivo foi ' + GetProcess(4) + '.';
    fsComplete: S := 'Operao concluda com sucesso.' + #13 + SArq;
    fsPartial: S := 'A operao no foi totalmente concluda.' + #13 + SArq;
    fsAborted: S := 'A operao foi interrompida pelo usurio.' + #13 + SArq;
    fsError: S := 'Ocorreram erros enquanto arquivos eram ' + GetProcess(1) + '.' + #13 + SArq;
  end;
  MessageDlg(S, mtInformation, [mbOk], 0);
  {restaura formulrio}
  BtnAcao.Enabled := True;
  BtnCancela.Enabled := False;
  Form1.Height := 225;
end;


{ FileManagerCreateDirectory }
procedure TForm1.FileManagerCreateDirectory(Sender: TObject; var CanCreate: Boolean);
var
  S: string;
begin
  {verifica se o usurio deseja criar o diretrio de destino}
  S := 'O diretrio de destino' + #13 + '' + FileManager.DirDest + '' + #13 +
    'no existe. Deseja cria-lo agora?';
  if MessageDlg(S, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    CanCreate := True;  {habilita a criao}
end;


{ FileManagerOverwrite }
procedure TForm1.FileManagerOverwrite(Sender: TObject; var CanOverwrite: Boolean);
var
  S: string;
begin
  {verifica se deve sobrescrever arquivo de destino}
  S := 'Deseja substituir o arquivo de destino:' + #13#13 +
    #09 + FileManager.InfoDest.Path + FileManager.InfoDest.Name + #13 +
    #09 + 'Modificado em ' + DateTimeToStr(FileDateToDateTime(FileManager.InfoDest.Time)) + #13#13 +
    'por este?' + #13#13 +
    #09 + FileManager.InfoSrc.Path + FileManager.InfoSrc.Name + #13 +
    #09 + 'Modificado em ' + DateTimeToStr(FileDateToDateTime(FileManager.InfoSrc.Time));
  if MessageDlg(S, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    CanOverwrite := True;   {habilita a sobreposio}
end;


{ FileManagerError }
procedure TForm1.FileManagerError(Sender: TObject; Error: TEvFileError);
var
  S: string;
begin
  {garante que o cursor volte ao normal, mesmo ocorrendo algum erro}
  Screen.Cursor := crDefault;
  {determina a mensagem de acordo com o erro ocorrido}
  S := '';
  case Error of
    feInvalidSource: S := 'Nenhum arquivo atende  esta especificao:' + #13 + FileManager.Source;
    feAmbigDest: S := 'Diversos arquivos de origem para o mesmo arquivo de destino.';
    feSameFile: S := 'O arquivo de origem  o arquivo de destino.';
    feDirNotExists: S := 'Diretrio de destino no existe e no pode ser criado.';
    feOpenError: S := 'Erro na abertura do arquivo de origem.';
    feCreateError: S := 'Erro na criao do arquivo de destino.';
    feWriteError: S := 'Erro durante a gravao do arquivo de destino.';
    feDestExists: S := 'O arquivo de destino j existe.';
    feRenameError: S := 'Erro ao renomear arquivo.';
    feDiferentDir: S := 'No  possvel renomear porque o diretrio de destino  diferente.';
    feDeleteError: S := 'Erro ao deletar arquivo.';
    feNoSpace: S := 'No h espao suficiente para copiar o arquivo:' + #13 +
      FileManager.InfoDest.Path + FileManager.InfoDest.Name;
    feMoveError: S := 'Erro ao mover arquivo.';
  end;
  MessageDlg(S, mtInformation, [mbOk], 0);
end;


{ BtnFecharClick }
procedure TForm1.BtnFecharClick(Sender: TObject);
begin
  Close;
end;


{ BtnCancelaClick }
procedure TForm1.BtnCancelaClick(Sender: TObject);
begin
  FileManager.Abort;
end;


end.
