unit Unit1;

interface

uses
  Windows, SysUtils, Messages, Classes, Graphics, Controls, Forms, Dialogs, 
  StdCtrls, DBTables, DB, Printers, ExtCtrls, ERPrint;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Table1Name: TStringField;
    Table1Capital: TStringField;
    Table1Continent: TStringField;
    Table1Area: TFloatField;
    Table1Population: TFloatField;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    BtnRelatorio: TButton;
    RPrint1: TEvRPrint;
    Label3: TLabel;
    BtnOutros: TButton;
    procedure BtnRelatorioClick(Sender: TObject);
    procedure BtnOutrosClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BtnRelatorioClick(Sender: TObject);
var
  AreaTotal, PopTotal: Double;
  SArea, SPop: string;
begin
  Panel1.Enabled := False;
  Table1.DatabaseName := ExtractFilePath(Application.ExeName);
  Table1.Open;
  AreaTotal := 0;
  PopTotal := 0;
  {inicio rotina do relatrio}
  RPrint1.BeginDoc;
  RPrint1.Adjust(100);
  {imprime o ttulo com a fonte em tamanho maior}
  RPrint1.Font.Size := RPrint1.Font.Size + 5;
  RPrint1.Out('PAISES E INFORMAES', 99, [pcBold, pcCenter, pcLineFeed]);
  RPrint1.Font.Size := RPrint1.Font.Size - 5;
  {nome do relatrio e pgina}
  RPrint1.Out('Relatrio de Teste', 80, [pcBold]);
  RPrint1.Out('Pgina: ' + IntToStr(RPrint1.Page), 20, [pcBold, pcRight, pcLineFeed]);
  {imprime cabealho}
  RPrint1.Out('PAS', 26, [pcBold]);
  RPrint1.Out('CAPITAL', 25, [pcBold]);
  RPrint1.Out('CONTINENTE', 25, [pcBold]);
  RPrint1.Out('REA', 12, [pcBold, pcRight]);
  RPrint1.Out('POPULAO', 12, [pcBold, pcRight, pcLineFeed]);
  RPrint1.RectFill(0, RPrint1.Row - 1, 99, RPrint1.Row - 1, 2, 10, fsRandom);
  {imprime dados}
  while (not Table1.EOF) do
    begin
      AreaTotal := AreaTotal + Table1Area.AsFloat;
      PopTotal := PopTotal + Table1Population.AsFloat;
      SArea := FloatToStrF(Table1Area.AsFloat, ffNumber, 12, 0);
      SPop := FloatToStrF(Table1Population.AsFloat, ffNumber, 12, 0);
      {sada}
      RPrint1.Out(Table1Name.AsString, 26, []);
      RPrint1.Out(Table1Capital.AsString, 25, []);
      RPrint1.Out(Table1Continent.AsString, 25, []);
      RPrint1.Out(SArea, 12, [pcRight]);
      RPrint1.Out(SPop, 12, [pcRight, pcLineFeed]);
      Table1.Next;
    end;
  RPrint1.RectFill(0, RPrint1.Row - 18, 99, RPrint1.Row - 1, 2, 0, fsNone);
  {totais}
  SArea := FloatToStrF(AreaTotal, ffNumber, 12, 0);
  SPop := FloatToStrF(PopTotal, ffNumber, 12, 0);
  RPrint1.Out('TOTAIS', 76, [pcBold]);
  RPrint1.Out(SArea, 12, [pcBold, pcRight]);
  RPrint1.Out(SPop, 12, [pcBold, pcRight, pcLineFeed]);
  RPrint1.RectFill(0, RPrint1.Row - 1, 99, RPrint1.Row - 1, 2, 25, fsRegular);
  RPrint1.EndDoc;
  {fim da rotina do relatorio}
  Table1.Close;
  Panel1.Enabled := True;
end;


procedure TForm1.BtnOutrosClick(Sender: TObject);
begin
  Panel1.Enabled := False;
  {inicio rotina do relatrio}
  RPrint1.BeginDoc;
  RPrint1.Adjust(81);
  {justificao}
  RPrint1.Out('Para quem se acostumou com a maneira', 37, [pcJustify, pcLineFeed]);
  RPrint1.Out('de gerar relatrios no Clipper,', 37, [pcJustify, pcLineFeed]);
  RPrint1.Out('TRPrint  um bom componente para esta', 37, [pcJustify, pcLineFeed]);
  RPrint1.Out('finalidade. Possui diversos controles', 37, [pcJustify, pcLineFeed]);
  RPrint1.Out('como alinhamento e justificao de', 37, [pcJustify, pcLineFeed]);
  RPrint1.Out('texto, escolha da fonte, margens,', 37, [pcJustify, pcLineFeed]);
  RPrint1.Out('molduras e outros', 37, [pcLineFeed]);
  RPrint1.RectFill(0, RPrint1.Row - 7, 36, RPrint1.Row - 1, 2, 0, fsNone);
  {exemplos de preenchimentos randomicos}
  RPrint1.NewPos(0, 0);
  RPrint1.Out('05%', 45, [pcRight, pcLineFeed]);
  RPrint1.Out('10%', 45, [pcRight, pcLineFeed]);
  RPrint1.Out('15%', 45, [pcRight, pcLineFeed]);
  RPrint1.Out('25%', 45, [pcRight, pcLineFeed]);
  RPrint1.Out('35%', 45, [pcRight, pcLineFeed]);
  RPrint1.Out('50%', 45, [pcRight, pcLineFeed]);
  RPrint1.Out('70%', 45, [pcRight, pcLineFeed]);
  RPrint1.RectFill(46, RPrint1.Row - 7, 60, RPrint1.Row - 7, 2, 05, fsRandom);
  RPrint1.RectFill(46, RPrint1.Row - 6, 60, RPrint1.Row - 6, 2, 10, fsRandom);
  RPrint1.RectFill(46, RPrint1.Row - 5, 60, RPrint1.Row - 5, 2, 15, fsRandom);
  RPrint1.RectFill(46, RPrint1.Row - 4, 60, RPrint1.Row - 4, 2, 25, fsRandom);
  RPrint1.RectFill(46, RPrint1.Row - 3, 60, RPrint1.Row - 3, 2, 35, fsRandom);
  RPrint1.RectFill(46, RPrint1.Row - 2, 60, RPrint1.Row - 2, 2, 50, fsRandom);
  RPrint1.RectFill(46, RPrint1.Row - 1, 60, RPrint1.Row - 1, 2, 70, fsRandom);
  {exemplos de preenchimentos regulares}
  RPrint1.NewPos(0, 0);
  RPrint1.Out('15%', 65, [pcRight, pcLineFeed]);
  RPrint1.Out('20%', 65, [pcRight, pcLineFeed]);
  RPrint1.Out('25%', 65, [pcRight, pcLineFeed]);
  RPrint1.Out('30%', 65, [pcRight, pcLineFeed]);
  RPrint1.Out('40%', 65, [pcRight, pcLineFeed]);
  RPrint1.Out('50%', 65, [pcRight, pcLineFeed]);
  RPrint1.Out('75%', 65, [pcRight, pcLineFeed]);
  RPrint1.RectFill(66, RPrint1.Row - 7, 80, RPrint1.Row - 7, 2, 15, fsRegular);
  RPrint1.RectFill(66, RPrint1.Row - 6, 80, RPrint1.Row - 6, 2, 20, fsRegular);
  RPrint1.RectFill(66, RPrint1.Row - 5, 80, RPrint1.Row - 5, 2, 25, fsRegular);
  RPrint1.RectFill(66, RPrint1.Row - 4, 80, RPrint1.Row - 4, 2, 30, fsRegular);
  RPrint1.RectFill(66, RPrint1.Row - 3, 80, RPrint1.Row - 3, 2, 40, fsRegular);
  RPrint1.RectFill(66, RPrint1.Row - 2, 80, RPrint1.Row - 2, 2, 50, fsRegular);
  RPrint1.RectFill(66, RPrint1.Row - 1, 80, RPrint1.Row - 1, 2, 75, fsRegular);
  RPrint1.EndDoc;
  Panel1.Enabled := False;
end;

end.
