unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, 
  StdCtrls, ExtCtrls, EFiDown;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    EdtURL: TEdit;
    Label2: TLabel;
    EdtFile: TEdit;
    BtnBaixar: TButton;
    BtnAbortar: TButton;
    Panel2: TPanel;
    FileDownload1: TEvFileDownload;
    procedure BtnBaixarClick(Sender: TObject);
    procedure BtnAbortarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileDownload1Start(Sender: TObject);
    procedure FileDownload1Progress(Sender: TObject;
      BytesReceived: Integer);
    procedure FileDownload1End(Sender: TObject; BytesReceived: Integer;
      Success: Boolean);
    procedure FileDownload1Error(Sender: TObject; Error: TEvDownError);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  EdtFile.Text := LowerCase(ExtractFilePath(Application.ExeName)) + 'tcf.gif';
end;

procedure TForm1.BtnBaixarClick(Sender: TObject);
begin
  FileDownload1.FromURL := EdtURL.Text;
  FileDownload1.ToFile := EdtFile.Text;
  FileDownload1.Execute;
  BtnBaixar.Enabled := False;
end;

procedure TForm1.BtnAbortarClick(Sender: TObject);
begin
  FileDownload1.Abort;
  BtnBaixar.Enabled := True;
end;

procedure TForm1.FileDownload1Start(Sender: TObject);
begin
  Panel2.Caption := 'Abrindo ' + FileDownload1.FromURL;
end;

procedure TForm1.FileDownload1Progress(Sender: TObject;
  BytesReceived: Integer);
begin
  Panel2.Caption := IntToStr(BytesReceived) + ' bytes recebidos';
end;

procedure TForm1.FileDownload1End(Sender: TObject; BytesReceived: Integer;
  Success: Boolean);
begin
  Panel2.Caption := 'Download terminado.';
  BtnBaixar.Enabled := True;
  if Success then
    ShowMessage('O arquivo foi recebido com sucesso!');
end;

procedure TForm1.FileDownload1Error(Sender: TObject;
  Error: TEvDownError);
var
  U, F, S: string;
begin
  U := FileDownload1.FromURL;
  F := FileDownload1.ToFile;
  case Error of
    deInvalidURL: S := 'A URL ' + U + ' no  vlida.';
    deInvalidFile: S := F + ' no  um nome de arquivo vlido.';
    deOverwrite: S := 'O arquivo ' + F + ' j existe.';
    deDownloding: S := 'J est sendo baixado a URL ' + U;
    deConnect: S := 'No foi possvel estabelecer uma conexo com ' + U;
    deCreateFile: S := 'No foi possvel criar o arquivo ' + F;
    deOpenURL: S := 'No foi possvel abrir a URL ' + U;
    deWriteFile: S := 'Erro ao tentar granvar informaes no arquivo ' + F;
    deTimeOut: S := 'Tempo limite de operao esgotado. Tente novamente.';
    deAbort: S := 'O processo de download foi interrompido pelo usurio.';
  end;
  Panel2.Caption := S;
end;

end.
