unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, EAppUpd;

type
  TForm2 = class(TForm)
    PanFundo: TPanel;
    Bevel1: TBevel;
    GbxDados: TGroupBox;
    Label2: TLabel;
    GbxNova: TGroupBox;
    Label1: TLabel;
    Label6: TLabel;
    LabInfo: TLabel;
    PanBtn: TPanel;
    Image1: TImage;
    Bevel2: TBevel;
    BtnAtualizar: TButton;
    BtnCancelar: TButton;
    LabVersao: TLabel;
    LabData: TLabel;
    LabTamanho: TLabel;
    Bevel3: TBevel;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    ProgressBar1: TProgressBar;
    EvAppUpdate1: TEvAppUpdate;
    LabAndamento: TLabel;
    procedure FormShow(Sender: TObject);
    procedure EvAppUpdate1AppIsUpdated(Sender: TObject);
    procedure EvAppUpdate1DownloadProgress(Sender: TObject; BytesTotal,
      BytesReceived: Double);
    procedure EvAppUpdate1Error(Sender: TObject; Error: TEvUpdateError);
    procedure EvAppUpdate1NewVersion(Sender: TObject;
      Flags: TEvUpdateFlags; Info, Version: String; Size,
      Datetime: Integer; var Continue: Boolean);
    procedure BtnAtualizarClick(Sender: TObject);
    procedure BtnCancelarClick(Sender: TObject);
    procedure EvAppUpdate1RequestLogout(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

var
  Operacao: Integer;

const
  OPERACAO_AGUARDANDO = 0;
  OPERACAO_ATUALIZAR  = 1;
  OPERACAO_CANCELAR   = 2;

{$R *.dfm}

// FormShow
procedure TForm2.FormShow(Sender: TObject);
begin
  // ajusta os controles
  LabVersao.Caption := 'Obtendo informaes...';
  LabData.Caption := '';
  LabTamanho.Caption := '';
  LabInfo.Caption := '';
  BtnAtualizar.Enabled := False;
  BtnCancelar.Enabled := False;
  ProgressBar1.Position := 0;

  // verifica se existe atualizao
  EvAppUpdate1.Execute;
end;


// EvAppUpdate1AppIsUpdated
procedure TForm2.EvAppUpdate1AppIsUpdated(Sender: TObject);
begin
  // este evento  acionado se no for encontrada
  // nenhuma atualizao para a aplicao.
  ShowMessage('Nenhuma atualizao encontrada.');
  Close;
end;


// EvAppUpdate1DownloadProgress
procedure TForm2.EvAppUpdate1DownloadProgress(Sender: TObject; BytesTotal, BytesReceived: Double);
begin
  // use este evento para informar ao usurio o progresso do download da atualizao
  LabAndamento.Caption := IntToStr(Round(BytesReceived/1024)) +
    'KB de ' + IntToStr(Round(BytesTotal/1024)) + 'KB';
  ProgressBar1.Position := Round((BytesReceived/BytesTotal)*100);
end;


// EvAppUpdate1Error
procedure TForm2.EvAppUpdate1Error(Sender: TObject; Error: TEvUpdateError);
begin
  // este evento  acionado quando algum erro impede a atualizao
  // a mensagem ser exibida somente se o formulrio estiver ativo (Visible = True)
  if Visible then
    begin
      case Error of
        ueInvalidURL: ShowMessage('O endereo no Servidor de atualizao no  vlido.');
        ueControlFile: ShowMessage('No foi possvel baixar o arquivo de controle da atualizao.');
        ueApplicationFile: ShowMessage('No foi possvel baixar o arquivo da atualizao.');
        ueInvalidControlFile: ShowMessage('O arquivo de controle da atualizao no  vlido.');
        ueUpdateError: ShowMessage('Um erro impediu a concluso do processo de atualizao.');
        ueAborted: ShowMessage('O processo de atualizao foi abortado pelo usurio.');
      end;
      Close;
    end;
end;


// EvAppUpdate1NewVersion
procedure TForm2.EvAppUpdate1NewVersion(Sender: TObject; Flags: TEvUpdateFlags;
  Info, Version: String; Size, Datetime: Integer; var Continue: Boolean);
begin
  // informaes da NOVA aplicao. Observe que as variveis Version, Datetime, Size e Info foram
  // recebidas como parmetros do evento OnNewVersion
  LabVersao.Caption := Version;
  LabData.Caption := DateToStr(FileDateToDateTime(Datetime));
  LabTamanho.Caption := FormatFloat('#,##0', Size/1024) + 'KB';
  LabInfo.Caption := Info;

  BtnAtualizar.Enabled := True;
  BtnCancelar.Enabled := True;

  // macete! -> aguarda que um dos botes (Atualizar ou Cancelar) seja pressionado.
  //            Quando um boto for pressionado, o valor da vairvel Operacao ser
  //            alterado para 1 (Atualizar) ou 2 (Cancelar)
  Operacao := OPERACAO_AGUARDANDO;
  while Operacao = OPERACAO_AGUARDANDO do
    Application.ProcessMessages;

  if Operacao = OPERACAO_ATUALIZAR then
    Continue := True
  else if Operacao = OPERACAO_CANCELAR then
    begin
      Continue := False;
      PostMessage(Handle, WM_CLOSE, 0, 0);
    end;
end;


// BtnAtualizarClick
procedure TForm2.BtnAtualizarClick(Sender: TObject);
begin
  Operacao := OPERACAO_ATUALIZAR;
end;


// BtnCancelarClick
procedure TForm2.BtnCancelarClick(Sender: TObject);
begin
  if Operacao = OPERACAO_AGUARDANDO then
    Operacao := OPERACAO_CANCELAR
  else if Operacao = OPERACAO_ATUALIZAR then
    EvAppUpdate1.Abort;
end;


// EvAppUpdate1RequestLogout
procedure TForm2.EvAppUpdate1RequestLogout(Sender: TObject);
begin
  ShowMessage('A atualizao foi baixada com sucesso.'#13'Encerre esta aplicao para concluir o processo de atualizao.');
  Close;
end;

end.
